* Program Name: avi.prg 
* Author: Pat Y. Boens 
* Copyright (c) 1995 by FoxPro Xbase Focus
*Ŀ
* Created: 14 January 1995 at 18:06                                        
*                                                                          
* ........................................................................ 
* Revision number : 1.0 Last Revised : 25 January 1995 at 18:06            
*                                                                          
* Description : This is a very small demo of what can be achieved thanks   
*               to FOCUS.FLL in the field of MCI (Media Control Interface) 
*                                                                          
*               AVI                                                        
*                                                                          
* ........................................................................ 
*                                                                          
*                  Ŀ                  
*Ĵ FoxPro Xbase Focus rights reserved 
*                   

#define GRAY                    RGB( 128,128,128,128,128,128 )
#define WHITE                   RGB( 255,255,255,255,255,255 )

PARAMETER m.cAVIFile

IF ( PARAMETERS() == 0 )

    WAIT WINDOW "Syntax : DO AVI WITH <file.AVI>"
    RETURN TO MASTER

ELSE

    IF ( ! FILE( m.cAVIFile ) )
        WAIT WINDOW "AVI file not found"
        RETURN TO MASTER
    ENDIF

ENDIF

DO Init                                && Initialization stage
DO Main                                && Main stuff

PROCEDURE Init

    SET LIBRARY TO FOCUS.FLL           && Let's load the library !

RETURN

PROCEDURE main
    PRIVATE m.hwnd                     && HWND of our window
    PRIVATE m.bPlay                    && Play button
    PRIVATE m.bHome                    && Home button
    PRIVATE m.bEnd                     && End button
    PRIVATE m.bStop                    && Stop button
    PRIVATE m.bPause                   && Pause button

    PRIVATE m.aFiles                   && Popup
    PRIVATE m.nAnswer

    m.bPlay  = 1
    m.bHome  = 1
    m.bEnd   = 1
    m.bStop  = 1
    m.bPause = 1
    m.nAnswer = 1

    DEFINE WINDOW wPatVideo       ;
        AT 00.00,00.00            ;
        SIZE 22.00,50.5           ;
        TITLE "VIDEO"             ;
        SYSTEM                    ;
        FONT "Arial",12           ;
        FLOAT                     ;
        NOCLOSE                   ;
        MINIMIZE                  ;
        COLOR RGB(,,,192,192,192)

    ACTIVATE WINDOW wPatVideo NOSHOW   && Activate but remains hidden
    MOVE WINDOW wPatVideo CENTER       && Move it to the center

    @ 18,03 GET m.bPlay PICT "@*HN Play"  STYLE "B" SIZE 2,7 VALID True( "play AVI window" )
    @ 18,12 GET m.bHome PICT "@*HN Home"  STYLE "B" SIZE 2,7 VALID True( "seek AVI to start" )
    @ 18,21 GET m.bEnd  PICT "@*HN End"   STYLE "B" SIZE 2,7 VALID True( "seek AVI to end" )
    @ 18,30 GET m.bStop PICT "@*HT Stop"  STYLE "B" SIZE 2,7 VALID True( "stop AVI" )
    @ 18,39 GET m.bStop PICT "@*HN Pause" STYLE "B" SIZE 2,7 VALID True( "pause AVI" )

    @ 21.10,00.50 SAY "The FOCUS Video viewer" FONT "Times New Roman",8

    m.hwnd = WIN_hwnd( "VIDEO" )       && HWND of the window

    =MCI_send( "open "              + ;
               m.cAVIFile           + ;
               " alias AVI parent " + ;
               ALLTRIM(STR(m.hwnd)) + ;
               " style child" )
    =MCI_send( "put AVI window at " + Adapt( MCI_send( "where AVI source" ) ) )

    IF ( MCI_device( "AVI" ) == 0 )
        WAIT WINDOW "Cannot open Digital Video device" + ;
                    CHR(13) + CHR(10)                  + ;
                    "Check your DRIVERS of the Control panel"
        RETURN TO MASTER
    ENDIF

    =SCR_relief( 0.5 ,0.5,16.8,50 )    && Border around Motion Picture
    =SCR_relief( 17.5,0.5,21  ,50 )    && Border around buttons
    
    ACTIVATE WINDOW wPatVideo          && Activated and visible
    READ MODAL                         && READ

    =MCI_send( "close AVI" )           && Clause MCI device

    RELEASE WINDOW wPatVideo           && Release window

RETURN

*----------------------------------------------------------------------*

FUNCTION True                          && .T. function
    PARAMETER m.cMCICmd

    =MCI_send( m.cMCICmd )             && Send the MCI command

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION SCR_relief
    PARAMETERS m.nTop,m.nLeft,m.nBottom,m.nRight

    *-- Ŀ
    *--  PURPOSE : 3D effect                                          
    *-- 

    PRIVATE m.nEcart,m.nEcartc
    PRIVATE m.cFont
    PRIVATE m.nSize

    m.cFont   = WFONT( 1 )
    m.nSize   = WFONT( 2 )

    m.nEcart  = 3/FONTMETRIC( 1,m.cFont,m.nSize )
    m.nEcartc = 3/FONTMETRIC( 6,m.cFont,m.nSize )

    IF ( m.nBottom > WROWS() )
        m.nBottom = WROWS() - 0.500
    ENDIF

    IF ( m.nRight > WCOLS() )
        m.nRight = WCOLS() - 0.500
    ENDIF

    @ m.nTop   ,m.nLeft    TO m.nBottom,m.nLeft  PEN 1,8
    @ m.nTop   ,m.nLeft    TO m.nTop   ,m.nRight PEN 1,8 STYLE "1"
    @ m.nTop   ,m.nRight   TO m.nBottom,m.nRight PEN 1,8           COLOR WHITE
    @ m.nBottom,m.nLeft    TO m.nBottom,m.nRight PEN 1,8 STYLE "1" COLOR WHITE

    @ m.nTop    + m.nEcart    , ;
      m.nLeft   + m.nEcartc TO  ;
      m.nBottom - m.nEcart    , ;
      m.nLeft   + m.nEcartc     ;
    PEN 1,8                     ;
    COLOR WHITE

    @ m.nTop    + m.nEcart    , ;
      m.nLeft   + m.nEcartc TO  ;
      m.nTop    + m.nEcart    , ;
      m.nRight  - m.nEcartc     ;
    PEN 1,8                     ;
    STYLE "1"                   ;
    COLOR WHITE

    @ m.nTop    + m.nEcart    , ;
      m.nRight  - m.nEcartc TO  ;
      m.nBottom - m.nEcart    , ;
      m.nRight  - m.nEcartc     ;
    PEN 1, 8

    @ m.nBottom - m.nEcart    , ;
      m.nLeft   + m.nEcartc TO  ;
      m.nBottom - m.nEcart    , ;
      m.nRight  - m.nEcartc     ;
    PEN 1,8                     ;
    STYLE "1"

RETURN ( .T. )

*----------------------------------------------------------------------*

FUNCTION Adapt
    PARAMETER m.cCoord

    PRIVATE m.cOldSep
    PRIVATE m.cNewCoord

    m.cOldSep   = STR_setsep( " " )

    m.cNewCoord = Num2Str( VAL( STR_ntoken( 1,m.cCoord ) ) + 15 ) + " " + ;
                  Num2Str( VAL( STR_ntoken( 2,m.cCoord ) ) + 20 ) + " " + ;
                                STR_ntoken( 3,m.cCoord )          + " " + ;
                                STR_ntoken( 4,m.cCoord )

    =STR_setsep( m.cOldSep )

RETURN ( m.cNewCoord )

*----------------------------------------------------------------------*

FUNCTION Num2Str
    PARAMETER m.nNum

RETURN ( ALLTRIM( STR( m.nNum ) ) )

*----------------------------------------------------------------------*



